from sonador.parser import add_arguments_for_api_connection, add_arguments_for_verify_ssl, \
	add_arguments_for_logging_options, output_operation_options, \
	output_destination_options, SONADOR_COMMAND_LIST, SONADOR_COMMAND_DETAILS, \
	OUTPUT_TYPE_TABULATE, OUTPUT_TYPE_CSV


# General API Commands
SONADOR_COMMAND_TOKEN = 'session-token'
SONADOR_COMMAND_QUERY = 'query'
SONADOR_COMMAND_FETCH = 'fetch'
SONADOR_COMMAND_MODIFY = 'modify'
SONADOR_COMMAND_DOWNLOAD = 'download'
SONADOR_COMMAND_REMOTE = 'remote'
SONADOR_COMMAND_REMOVE = 'rm'
SONADOR_COMMAND_QUERY_DOWNLOAD = '%s-%s' % (SONADOR_COMMAND_QUERY, SONADOR_COMMAND_DOWNLOAD)
SONADOR_COMMAND_QUERY_FETCH = '%s-%s' % (SONADOR_COMMAND_QUERY, SONADOR_COMMAND_FETCH)
SONADOR_COMMAND_QUERY_REMOVE = '%s-%s' % (SONADOR_COMMAND_QUERY, SONADOR_COMMAND_REMOVE)

# Modality API
SONADOR_COMMAND_MODALITY = 'dcm'
SONADOR_COMMAND_SUPPORTED_MODALITY = (SONADOR_COMMAND_LIST, SONADOR_COMMAND_DETAILS)

# DICOMweb API
SONADOR_COMMAND_DICOMWEB = 'dcm-web'
SONADOR_COMMAND_SUPPORTED_DICOMWEB = (SONADOR_COMMAND_LIST, SONADOR_COMMAND_DETAILS, SONADOR_COMMAND_REMOTE)

# Patient API
SONADOR_COMMAND_PATIENT = 'patient'
SONADOR_COMMAND_PATIENT_SUPPORTED = (SONADOR_COMMAND_QUERY, SONADOR_COMMAND_DETAILS, SONADOR_COMMAND_MODIFY, SONADOR_COMMAND_DOWNLOAD,
	SONADOR_COMMAND_QUERY_DOWNLOAD, SONADOR_COMMAND_REMOVE, SONADOR_COMMAND_QUERY_REMOVE)

# Study API
SONADOR_COMMAND_STUDY = 'study'
SONADOR_COMMAND_STUDY_SUPPORTED = (SONADOR_COMMAND_QUERY, SONADOR_COMMAND_DETAILS, SONADOR_COMMAND_MODIFY, SONADOR_COMMAND_DOWNLOAD,
	SONADOR_COMMAND_QUERY_DOWNLOAD, SONADOR_COMMAND_REMOVE, SONADOR_COMMAND_QUERY_REMOVE)

# Image API
SONADOR_COMMAND_IMAGE = 'image'
SONADOR_COMMAND_IMAGE_UPLOAD = 'upload'
SONADOR_COMMAND_SUPPORTED_IMAGE = (
	SONADOR_COMMAND_IMAGE_UPLOAD, SONADOR_COMMAND_QUERY, SONADOR_COMMAND_DETAILS, SONADOR_COMMAND_MODIFY, SONADOR_COMMAND_DOWNLOAD,
	SONADOR_COMMAND_QUERY_DOWNLOAD, SONADOR_COMMAND_REMOVE, SONADOR_COMMAND_QUERY_REMOVE)


# Jobs API
SONADOR_COMMAND_JOB = 'job'
SONADOR_COMMAND_PAUSE = 'pause'
SONADOR_COMMAND_RESUME = 'resume'
SONADOR_COMMAND_CANCEL = 'cancel'
SONADOR_COMMAND_RESUBMIT = 'resubmit'
SONAOD_COMMAND_SUPPORTED_JOB = (SONADOR_COMMAND_LIST, SONADOR_COMMAND_DETAILS, SONADOR_COMMAND_PAUSE,
	SONADOR_COMMAND_CANCEL, SONADOR_COMMAND_RESUBMIT)


# Image Server API
SONADOR_COMMAND_IMAGE_SERVER = 'pacs'
SONADOR_COMMAND_SUPPORTED_IMAGE_SERVER = (SONADOR_COMMAND_LIST, SONADOR_COMMAND_DETAILS, SONADOR_COMMAND_MODALITY, 
	SONADOR_COMMAND_DICOMWEB, SONADOR_COMMAND_PATIENT, SONADOR_COMMAND_STUDY, SONADOR_COMMAND_IMAGE, SONADOR_COMMAND_JOB)


# DICOMweb Remote API
SONADOR_COMMAND_DICOMWEB_REMOTE_SUPPORTED = (SONADOR_COMMAND_STUDY, SONADOR_COMMAND_IMAGE)
SONADOR_COMMAND_DICOMWEB_REMOTECMD_SUPPORTED = (SONADOR_COMMAND_QUERY, SONADOR_COMMAND_FETCH, SONADOR_COMMAND_QUERY_FETCH)


SONADOR_SUPPORTED_COMMANDS = (SONADOR_COMMAND_IMAGE_SERVER, SONADOR_COMMAND_TOKEN)
